/*

Third robot test program. Moving the robot to a bunch
of landmarks given in a local coordinate frame.

You can copy this and put your own material between these comments.

dml 2009
 */


#include <stdlib.h>
#include <limits.h>
#include<math.h>
#include<string.h>
#include "Aria.h"


int main(int argc, char **argv)
{
  /* DECLARATIONS */

  ArArgumentParser parser(&argc, argv);    // set up our parser
  ArSimpleConnector 
             simpleConnector(&parser);     // set up our simple connector
  ArRobot robot;                           // declare robot object


  /* INITIALIZATION OF CONNECTION TO ROBOT */

  Aria::init();                             // mandatory init

  parser.loadDefaultArguments();           // load the default arguments 

  if (!simpleConnector.parseArgs()         // check command line args
                || !parser.checkHelpAndWarnUnparsed(1))
  {    
    simpleConnector.logOptions();
    Aria::shutdown();
    return 1;
  }


  if (!simpleConnector.connectRobot(&robot)) // ask for connection to robot
  {
    printf("Could not connect to robot... exiting\n");
    Aria::shutdown();
    return 1;
  }

  /* INITIALIZATION OF ROBOT*/

  robot.runAsync(true);
  robot.enableMotors();


  /* ****** DO SOMETHING INTERESTING WITH THE ROBOT HERE ****** */
  
  ArVCC4 myPTZ(&robot);

  myPTZ.reset(); ArUtil::sleep(10000);

//  for (int i=0; i<=40; i+=10) 
//    for (int j =0; j<=40; j+=10) {
	printf("move camera");
      myPTZ.panTilt((double)(0), (double)(-7.25));
//      printf("Pan-tilt to %d deg %d deg\n",i-20,j-20);
      ArUtil::sleep(20000);
      printf("Actual pan tilt %lf deg %lf deg\n",
	     myPTZ.getPan(), myPTZ.getTilt());
//    }

  printf("Done.\n");

  /* ****** END OF SOMETHING INTERESTING WITH THE ROBOT HERE ****** */

  Aria::shutdown();
  return 0;


}
