#include <iostream>
#include "pcl/io/pcd_io.h"
#include "pcl/point_types.h"
#include "pcl/filters/voxel_grid.h"

int
main (int argc, char** argv)
{
  typedef pcl::PointXYZRGB PointT;

  if(argc != 3)
    {
      std::cout << "Inproper command line arguments. Please enter: downsample <input.pcd> <output.pcd>\n";
      return -1;
    }

  pcl::PointCloud<PointT>::Ptr cloud(new pcl::PointCloud<PointT>);
  pcl::PointCloud<PointT>::Ptr cloud_filtered(new pcl::PointCloud<PointT>);
  //  sensor_msgs::PointCloud2::Ptr cloud (new sensor_msgs::PointCloud2 ());
  //  sensor_msgs::PointCloud2::Ptr cloud_filtered (new sensor_msgs::PointCloud2 ());

  // Fill in the cloud data
  pcl::PCDReader reader;
  // Replace the path below with the path where you saved your file
  reader.read (argv[1], *cloud); // Remember to download the file first!

  std::cout << "PointCloud before filtering: " << *cloud << std::endl;

  // Create the filtering object
  pcl::VoxelGrid<PointT> sor;
  sor.setInputCloud (cloud);
  sor.setLeafSize (0.01, 0.01, 0.01); //1 mm^3
  sor.filter (*cloud_filtered);

  std::cerr << "PointCloud after filtering: " << *cloud << std::endl;

  pcl::PCDWriter writer;
  writer.write (argv[2], *cloud_filtered, true);
		//                ,Eigen::Vector4f::Zero (), Eigen::Quaternionf::Identity (), false);

  return (0);
}
