#include <iostream>
#include <cstdio>
#include "pcl/io/pcd_io.h"
#include "pcl/point_types.h"

#include <pcl/filters/passthrough.h>
// Add to CmakeLists.txt for pclICP
//
//add_executable (pclICP pclICP.cpp)
//target_link_libraries (pclICP pcl_io pcl_registration)
//


using namespace pcl;
using namespace pcl::io;
using namespace std;

typedef PointXYZRGB PointT;

int main(int argc, char** argv)
{

  cout << "This version of floorcut assumes that" << endl;
  cout << "the points are still in the coordinate" << endl;
  cout << "frame of the bumblebee camera that is " << endl;
  cout << "at location 0,0, and the floor is at  " << endl;
  cout << "(x, y>+.43 m, z). Also I built in a 3 cm" << endl;
  cout << "buffer above the floor to make sure it is cut" << endl;

  PointCloud<PointT>::Ptr cloud(new   PointCloud<PointT>);
  PointCloud<PointT>::Ptr cloud_filtered(new   PointCloud<PointT>);

  pcl::PCDReader reader;
  reader.read<PointT> (argv[1], *cloud);

  PassThrough<PointT> pass;
  pass.setInputCloud(cloud);
  pass.setFilterFieldName("y");
  pass.setFilterLimits(-5.0,.4); //5 m above camera, and down to almost the floor
  pass.filter(*cloud_filtered);

  pcl::PCDWriter writer;
  writer.write<PointT> (argv[2], *cloud_filtered, true);

  return 0;
}
