#include <iostream>
#include "pcl/io/pcd_io.h"
#include "pcl/point_types.h"
#include <string>

#include <stdio.h>

void rgbToRgba(const char* input, const char* output)
{
  pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGB>);
  pcl::PointCloud<pcl::PointXYZRGBA>::Ptr cloud2(new pcl::PointCloud<pcl::PointXYZRGBA>);

  pcl::io::loadPCDFile(std::string(input), *cloud);

  pcl::copyPointCloud<pcl::PointXYZRGB,pcl::PointXYZRGBA> (*cloud, *cloud2);

  pcl::io::savePCDFile(std::string(output), *cloud2);

  return;  
}
/*
void rgbToRgba(const char* input, const char* output)
{
  pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGB>);
  pcl::PointCloud<pcl::PointXYZRGBA>::Ptr cloud2(new pcl::PointCloud<pcl::PointXYZRGBA>);

  pcl::io::loadPCDFile(std::string(input), *cloud);

  pcl::copyPointCloud<pcl::PointXYZRGBA,pcl::PointXYZRGB> (*cloud, *cloud2);

  pcl::io::savePCDFile(std::string(output), *cloud2);

  return;  
}
*/
void bruteForceCopy(const char* input, const char* output)
{
  pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGB>);
  pcl::PointCloud<pcl::PointXYZRGBA>::Ptr cloud2(new pcl::PointCloud<pcl::PointXYZRGBA>);

  pcl::io::loadPCDFile(std::string(input), *cloud);

  cloud2->width = cloud->width;
  cloud2->height = cloud->height;

  cloud2->points.resize(cloud2->width*cloud2->height);

  for(size_t i = 0; i<cloud->points.size(); ++i)
    {
      cloud2->points[i].x = cloud->points[i].x;
      cloud2->points[i].y = cloud->points[i].y;
      cloud2->points[i].z = cloud->points[i].z;
      cloud2->points[i].r = cloud->points[i].r;
      cloud2->points[i].g = cloud->points[i].g;
      cloud2->points[i].b = cloud->points[i].b;
    }
  pcl::io::savePCDFile(std::string(output),*cloud2);

}

void bruteForceCopyToRGB(const char* input, const char* output)
{
  pcl::PointCloud<pcl::PointXYZRGBA>::Ptr cloud(new pcl::PointCloud<pcl::PointXYZRGBA>);
  pcl::PointCloud<pcl::PointXYZRGB>::Ptr cloud2(new pcl::PointCloud<pcl::PointXYZRGB>);

  pcl::io::loadPCDFile(std::string(input), *cloud);

  cloud2->width = cloud->width;
  cloud2->height = cloud->height;

  cloud2->points.resize(cloud2->width*cloud2->height);

  for(size_t i = 0; i<cloud->points.size(); ++i)
    {
      cloud2->points[i].x = cloud->points[i].x;
      cloud2->points[i].y = cloud->points[i].y;
      cloud2->points[i].z = cloud->points[i].z;
      cloud2->points[i].r = cloud->points[i].r;
      cloud2->points[i].g = cloud->points[i].g;
      cloud2->points[i].b = cloud->points[i].b;
    }
  pcl::io::savePCDFile(std::string(output),*cloud2);

}


int main(int argc, char** argv)
{
  bruteForceCopy(argv[1],argv[2]);

  return 0;
}
